/* add.c */
int add(int, char *[]);
static add_directory(char *);
static add_usage(void);

/* build_entry.c */
int Build_Entry(char *);

/* checkin.c */
int Checkin(char *, char *);
static restore_branch(void);

/* checkout.c */
int checkout(int, char *[]);
int Build_Dirs_and_chdir(char *);
static checkout_usage(void);

/* collect_sets.c */
int Collect_Sets(int, char *[]);

/* commit.c */
int commit(int, char *[]);
static commit_process_lists(char *, char *);
static lock_RCS(char *);
static branch_number(char *, char *);
static setup_tmpfile(FILE *, char *);
static fmt(FILE *, char *, char *);
static do_editor(char *);
int Update_Logfile(char *, char *);
static logfile_write(char *, char *, char *, char *);
static fix_rcs_modes(char *, char *);
static commit_usage(void);

/* create_admin.c */
int Create_Admin(char *, char *);

/* diff.c */
int diff(int, char *[]);
int diff_usage(void);

/* entries_file.c */
int Entries2Files(void);

/* find_names.c */
int Find_Names(int *, char *[], enum ftype);
static find_rcs(char *, int *, char *[]);
static addname(int *, char *[], char *);

/* join.c */
int join(int, char *[]);
static join_file(char *);
static join_usage(void);

/* locate_rcs.c */
int Locate_RCS(void);

/* log.c */
int log(int, char *[]);
static log_usage(void);

/* main.c */
int main(int, char *[]);
static usage(void);

/* maketime.c */
int Make_Date(const char *, char *);
int libId(int , int );
static time_t maketime(const struct tm *, int);
static const struct tm *time2tm(time_t);
void time2date(time_t, char[]);
void str2date(const char *, char[]);

/* mkmodules.c */
int main(int, char *[]);
static make_tempfile(char *, char *);
static checkout_file(char *, char *);
static write_dbmfile(char *);
static rename_dbmfile(char *);
static rename_loginfo(char *);
void Lock_Cleanup(int);
static mkmodules_usage(void);

/* modules.c */
DBM *open_module(void);
int close_module(DBM *);
int do_module(DBM *, char *, enum mtype, char *);
static process_module(int, char *[], enum mtype, datum *);
int cat_module(void);

/* name_repository.c */
int Name_Repository(void);

/* no_difference.c */
int No_Difference(int);

/* options.c */
int Get_Options(int, char *[]);

/* partime.c */
int libId(int , int );
static int goodzone(const struct token *, int, int *);
int partime(const char *, struct tm *, int *);
static int ptstash(int *, int);
static int pt12hack(struct tm *, int);
static int ptitoken(struct token *);
static int pttoken(struct token *);
static const struct tmwent *ptmatchstr(const char *, int, const struct tmwent *);

/* patch.c */
int patch(int, char *[]);
int patched(char *);
static patch_file(char *);
void patch_cleanup(int);
static get_rcsdate(char *, char *, char *);
static patch_usage(void);

/* register.c */
int Register(char *, char *, char *);

/* remove.c */
int _remove(int, char *[]);
static remove_usage(void);

/* scratch_entry.c */
int Scratch_Entry(char *);

/* set_lock.c */
void Lock_Cleanup(int);
int Reader_Lock(void);
int Writer_Lock(void);
static readers_exist(void);
static set_lock(char *);

/* status.c */
int status(int, char *[]);
static status_usage(void);

/* subr.c */
int error(int, char *, ... );
int warn(int, char *, ... );
int copy_file(char *, char *);
int isdir(char *);
int islink(char *);
int isfile(char *);
int isreadable(char *);
int iswritable(char *);
FILE *open_file(char *, char *);
int make_directory(char *);
char *xmalloc(int);
int ppstrcmp(char **, char **);
int ppstrcmp_files(char **, char **);
int xchmod(char *, int);
int rename_file(char *, char *);
int xcmp(char *, char *);
int free_names(int *, char *[]);
int line2argv(int *, char *[], char *);
int numdots(char *);

/* tag.c */
int tag(int, char *[]);
int tagit(char *);
int tag_file(char *);
static tag_usage(void);

/* update.c */
int update(int, char *[]);
static update_process_lists(void);
static update_make_dirs(int);
static update_descend(int);
static update_descend_dir(char *);
int isemptydir(char *);
static update_usage(void);

/* version_number.c */
int Version_Number(char *, char *, char *, char *);
static get_version(FILE *, char *, char *, char *, char *);
static get_tag(FILE *, char *, char *, char *);
static get_branch(FILE *, char *);
static get_date(FILE *, char *, char *, char *);
static get_branch_date(FILE *, char *, char *, char *);
int datecmp(char *, char *);

/* version_ts.c */
int Version_TS(char *, char *, char *);
static time_stamp(char *, char *);


/* dir.c */
int sleep(int);

/* getopt.c */
int getopt(int, char **, char *);

/* pipe.c */
FILE *popen(char *, char *);
int pclose(FILE *);

/* regex.c */
char *re_comp(char *);
int re_exec(char *);
